<?php
/**
*
* @package phpBB3
* @version $Id: index.php 231 2009-06-30 19:51:35Z lefty74 $
* @copyright (c) 2009 lefty74
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
define('IN_INSTALL', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/acp/acp_modules.' . $phpEx);
include($phpbb_root_path . 'includes/db/db_tools.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup(array('mods/info_acp_user_reminder', 'mods/acp_user_reminder', 'acp/common', 'install'));
$action = request_var('action', '');	

// CURRENT VERSION
$current_version = '1.0.5';

// Before we do anything, lets see if an Admin is calling this file
if (!$auth->acl_get('a_'))
{
	trigger_error('NO_ADMIN');
}

$msg = '';

switch ($action)
{
	case 'uninstall_complete':
	case 'install_complete':

		$sql = 'DELETE 
		FROM ' . STYLES_TEMPLATE_DATA_TABLE . "
		WHERE template_filename LIKE '" . $db->sql_escape('install_%') . "'";
		$result = $db->sql_query($sql);

		if ($action == 'install_complete')
		{
			$msg .= $user->lang['UR_INSTALL_COMPLETE'];
		}
		elseif ($action == 'uninstall_complete')
		{
			$msg .= $user->lang['UR_DELETE_COMPLETE'];
		}
		
		$msg .= sprintf($user->lang['UR_INSTALL_RETURN'], '<a href="' . append_sid("{$phpbb_root_path}index.$phpEx") . '">', '</a>');

						
		
		// Assign index specific vars
		$template->assign_vars(array(
			'TITLE'	=> $user->lang['TITLE'],
			'BODY'	=> $msg,
		));

	break;
	case 'install':
	case 'upgrade':
		
		$config_user_reminder_row = array(
		'user_reminder_last_auto_run'			=>	(isset($config['user_reminder_last_auto_run'])) ? $config['user_reminder_last_auto_run'] : 0,
		'user_reminder_ignore_no_email'			=>	(isset($config['user_reminder_ignore_no_email'])) ? $config['user_reminder_ignore_no_email'] : 0,
		'user_reminder_delete_choice'			=>	(isset($config['user_reminder_delete_choice'])) ? $config['user_reminder_delete_choice'] : 1,
		'user_reminder_zero_poster_enable'		=>	(isset($config['user_reminder_zero_poster_enable'])) ? $config['user_reminder_zero_poster_enable'] : 1,
		'user_reminder_zero_poster_days'		=>	(isset($config['user_reminder_zero_poster_days'])) ? $config['user_reminder_zero_poster_days'] : 15,
		'user_reminder_inactive_enable'			=>	(isset($config['user_reminder_inactive_enable'])) ? $config['user_reminder_inactive_enable'] : 1,
		'user_reminder_inactive_days'			=>	(isset($config['user_reminder_inactive_days'])) ? $config['user_reminder_inactive_days'] : 60,
		'user_reminder_inactive_still_enable'	=>	(isset($config['user_reminder_inactive_still_enable'])) ? $config['user_reminder_inactive_still_enable'] : 1,
		'user_reminder_inactive_still_days'		=>	(isset($config['user_reminder_inactive_still_days'])) ? $config['user_reminder_inactive_still_days'] : 30,
		'user_reminder_not_logged_in_enable'	=>	(isset($config['user_reminder_not_logged_in_enable'])) ? $config['user_reminder_not_logged_in_enable'] : 1,
		'user_reminder_not_logged_in_days'		=>	(isset($config['user_reminder_not_logged_in_days'])) ? $config['user_reminder_not_logged_in_days'] : 20,
		'user_reminder_enable'					=>	(isset($config['user_reminder_enable'])) ? $config['user_reminder_enable'] : 0,
		'user_reminder_users_per_page'			=>	(isset($config['user_reminder_users_per_page'])) ? $config['user_reminder_users_per_page'] : 0,
		
		
		'user_reminder_inactive_still_opt_zero'				=>	(isset($config['user_reminder_inactive_still_opt_zero'])) ? $config['user_reminder_inactive_still_opt_zero'] : 1,
		'user_reminder_inactive_still_opt_inactive'			=>	(isset($config['user_reminder_inactive_still_opt_inactive'])) ? $config['user_reminder_inactive_still_opt_inactive'] : 1,
		'user_reminder_inactive_still_opt_not_logged_in' 	=>	(isset($config['user_reminder_inactive_still_opt_not_logged_in'])) ? $config['user_reminder_inactive_still_opt_not_logged_in'] : 1,

		'user_reminder_log_opt_script'			=>	(isset($config['user_reminder_log_opt_script'])) ? $config['user_reminder_log_opt_script'] : 1,
		'user_reminder_log_opt_users_react'		=>	(isset($config['user_reminder_log_opt_users_react'])) ? $config['user_reminder_log_opt_users_react'] : 1,
		'user_reminder_log_opt_auto_emails' 	=>	(isset($config['user_reminder_log_opt_auto_emails'])) ? $config['user_reminder_log_opt_auto_emails'] : 1,
		);
		
		foreach ($config_user_reminder_row as $config_name => $config_value)
		{
			set_config($config_name, (int) $config_value);
		}
		
		$config_user_protected_row = array(
		'user_reminder_protected_users' 	=>	(isset($config['user_reminder_protected_users'])) ? $config['user_reminder_protected_users'] : '',
		'user_reminder_protected_group' 	=>	(isset($config['user_reminder_protected_group'])) ? $config['user_reminder_protected_group'] : '',
		'user_reminder_bcc_email' 			=>	(isset($config['user_reminder_bcc_email'])) ? $config['user_reminder_bcc_email'] : '',
		);
		
		foreach ($config_user_protected_row as $config_name => $config_value)
		{
			set_config($config_name, (string) $config_value);
		}
		
		$msg .=  '<span style="color:green;">- ' . $user->lang['UR_CONFIG_FIELDS_UPDATED_CREATED'] . '</span> <br/>';		

		
		
		// add the user table fields
		$_columns = new phpbb_db_tools($db);
		
		if (!$_columns->sql_column_exists(USERS_TABLE, 'user_reminder_inactive'))
		{
			$_columns->sql_column_add(USERS_TABLE, 'user_reminder_inactive', array('INT:11', '0'));
		}
		
		if (!$_columns->sql_column_exists(USERS_TABLE, 'user_reminder_zero_poster'))
		{
			$_columns->sql_column_add(USERS_TABLE, 'user_reminder_zero_poster', array('INT:11', '0'));
		}
		
		if (!$_columns->sql_column_exists(USERS_TABLE, 'user_reminder_inactive_still'))
		{
			$_columns->sql_column_add(USERS_TABLE, 'user_reminder_inactive_still', array('INT:11', '0'));
		}
		
		if (!$_columns->sql_column_exists(USERS_TABLE, 'user_reminder_not_logged_in'))
		{
			$_columns->sql_column_add(USERS_TABLE, 'user_reminder_not_logged_in', array('INT:11', '0'));
		}
		
		// lets add some indexes	
		if( !in_array('user_reminder_inactive', $_columns->sql_list_index(USERS_TABLE)))
		{
			$_columns->sql_create_index(USERS_TABLE, 'user_reminder_inactive', array('user_reminder_inactive'));
		}
		if( !in_array('user_reminder_zero_poster', $_columns->sql_list_index(USERS_TABLE)))
		{
			$_columns->sql_create_index(USERS_TABLE, 'user_reminder_zero_poster', array('user_reminder_zero_poster'));
		}
		if( !in_array('user_reminder_inactive_still', $_columns->sql_list_index(USERS_TABLE)))
		{
			$_columns->sql_create_index(USERS_TABLE, 'user_reminder_inactive_still', array('user_reminder_inactive_still'));
		}
		if( !in_array('user_reminder_not_logged_in', $_columns->sql_list_index(USERS_TABLE)))
		{
			$_columns->sql_create_index(USERS_TABLE, 'user_reminder_not_logged_in', array('user_reminder_not_logged_in'));
		}
					
		$msg .=  '<span style="color:green;">- ' . $user->lang['UR_USER_FIELDS_ADDED'] . '</span> <br/>';		
		
		install_modules();
		
		$msg .=  '<span style="color:green;">- ' . $user->lang['UR_MODULE_ADDED'] . '</span> <br/>';		
		
		set_config('urmod_version', (string) $current_version);			

		global $cache;
		$cache->purge();
		add_log('admin', 'LOG_PURGE_CACHE');
						
		//don't know of a better fix but redirect to make sure to get the install html files out of the templates that are stored in the database after the cache purging
		$redirect = append_sid("{$phpbb_root_path}install/index.$phpEx", "action=install_complete");
		meta_refresh(3, $redirect);
	
		$msg .= $user->lang['UR_INSTALL_REDIRECT'];
		
		// Assign index specific vars
		$template->assign_vars(array(
			'TITLE'	=> $user->lang['TITLE'],
			'BODY'	=> $msg,
		));


	break;
	case 'uninstall':
	
			$user_reminder_row = array(
				'user_reminder_last_auto_run',
				'user_reminder_ignore_no_email',
				'user_reminder_delete_choice',
				'user_reminder_zero_poster_enable',
				'user_reminder_zero_poster_days',
				'user_reminder_inactive_enable',
				'user_reminder_inactive_days',
				'user_reminder_inactive_still_enable',
				'user_reminder_inactive_still_days',
				'user_reminder_not_logged_in_enable',
				'user_reminder_not_logged_in_days',
				'user_reminder_enable',
				'user_reminder_users_per_page',
				'user_reminder_bcc_email',
				
				
				'user_reminder_inactive_still_opt_zero',
				'user_reminder_inactive_still_opt_inactive',
				'user_reminder_inactive_still_opt_not_logged_in',
				
				'user_reminder_log_opt_script',
				'user_reminder_log_opt_users_react',
				'user_reminder_log_opt_auto_emails',
				
				'user_reminder_protected_users',
				'user_reminder_protected_group',
				'urmod_version',
			);
		
		foreach ($user_reminder_row as $config_name)
		{
			if ( isset($config_name) )
			{
				$sql = 'DELETE 
				FROM ' . CONFIG_TABLE . "
				WHERE config_name = '" . $db->sql_escape($config_name) . "'";
				$result = $db->sql_query($sql);
			}
		}

		$msg .= '<span style="color:green;">- ' . $user->lang['UR_TABLE_CONFIG_DELETE'] . '</span>';
					
		// install the modules
		install_modules('delete');
		$msg .= '<span style="color:green;">- ' . $user->lang['UR_MODULE_DELETED'] . '</span>';


		$_columns = new phpbb_db_tools($db);
		$_columns->sql_column_remove(USERS_TABLE, 'user_reminder_inactive');	
		$_columns->sql_column_remove(USERS_TABLE, 'user_reminder_zero_poster');	
		$_columns->sql_column_remove(USERS_TABLE, 'user_reminder_inactive_still');	
		$_columns->sql_column_remove(USERS_TABLE, 'user_reminder_not_logged_in');	
		
		$msg .= '<span style="color:green;">- ' . $user->lang['UR_USER_FIELDS_DELETED'] . '</span><br/>';
		
		//lets purge the cache
		global $cache;
		$cache->purge();
		add_log('admin', 'LOG_PURGE_CACHE');
					
		//don't know of a better fix but redirect to make sure to get the install html files out of the templates that are stored in the database after the cache purging
		$redirect = append_sid("{$phpbb_root_path}install/index.$phpEx", "action=uninstall_complete");
		meta_refresh(3, $redirect);

		$msg .= $user->lang['UR_UNINSTALL_REDIRECT'];
		
		// Assign index specific vars
		$template->assign_vars(array(
			'TITLE'	=> $user->lang['TITLE'],
			'BODY'	=> $msg,
		));
	break;


	default:
		
	$msg = '<span style="color:red; font-size:1.5em;">' . $user->lang['UR_BACKUP_WARN'] . '</span><br /><br />';				

	if (!isset($config['user_reminder_last_auto_run']) && !isset($config['urmod_version']))
	{
		$msg .= '<span style="color:red;">' . $user->lang['UR_INSTALL_DESC'] . '</span><br /><br />';				
		$msg .= '<a href="' . append_sid("{$phpbb_root_path}install/index.$phpEx", "action=install") . '">' . $user->lang['UR_NEW_INSTALL'] . '</a><br />';
	}
	else
	{
		$msg .= '<span style="color:red;">' . $user->lang['UR_UPGRADE_DESC'] . '</span><br /><br />';				

		if (!version_compare((isset($config['urmod_version']) ? $config['urmod_version'] : 0), $current_version, '=='))
		{
			$msg .= '<a href="' . append_sid("{$phpbb_root_path}install/index.$phpEx", "action=upgrade") . '">' . sprintf($user->lang['UR_UPGRADE'], $current_version) . '</a><br />';						
		}
		else
		{
			$msg .= sprintf($user->lang['UR_UP_TO_DATE'], $current_version) . '<br />';
		}
		

		$msg .= '<a href="' . append_sid("{$phpbb_root_path}install/index.$phpEx", "action=uninstall") . '"><br /><span style="color:red;">' . $user->lang['UR_UNINSTALL'] . '</span></a><br />';	
		
	}
								
	// Assign index specific vars
	$template->assign_vars(array(
		'TITLE'	=> $user->lang['TITLE'],
		'BODY'	=> $msg,
	));

}

// Output

// Output page
page_header($user->lang['INSTALL_PANEL']);

$template->set_custom_template('../adm/style', 'admin');
$template->assign_var('T_TEMPLATE_PATH', '../adm/style');

$template->set_filenames(array(
	'body' => 'install_main.html')
);

page_footer();

/**
* Check if the modules exists, then (delete and re-)add the modules
*
*/
function install_modules($type=false)
{
   global $db, $user;
		
	// Lets make sure this module does not get added a second time by accident
	$sql = 'SELECT parent_id
		FROM ' . MODULES_TABLE . "
		WHERE module_langname = '" . $db->sql_escape('ACP_USER_REMINDER_CONFIGURATION') . "'";
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);
	
	if ($row)
	{
	$sql = 'DELETE
		FROM ' . MODULES_TABLE . "
		WHERE (parent_id = '" . $row['parent_id'] . "'	OR	 module_id = '" . $row['parent_id'] . "')
			AND module_langname != '" . $db->sql_escape('ACP_CAT_DOT_MODS') . "'";
	$result = $db->sql_query($sql);
	
	}
	
	if ($type != 'delete')
	{
		// Lets get the .MOD module ID so we can insert our module there
		$sql = 'SELECT module_id
			FROM ' . MODULES_TABLE . "
			WHERE module_langname = '" . $db->sql_escape('ACP_CAT_DOT_MODS') . "'";
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
		
		$_module = new acp_modules();
		
		// So lets add the main category
		$user_reminder = array(
			'module_basename'	=> '',
			'module_enabled'	=> 1,
			'module_display'	=> 1,
			'parent_id'			=> (int) $row['module_id'],
			'module_class'		=> 'acp',
			'module_langname'	=> 'USER_REMINDER',
			'module_mode'		=> '',
			'module_auth'		=> '',
		);
		$_module->update_module_data($user_reminder);
		// Now the subcategories
		$user_reminder_configuration = array(
			'module_basename'	=> 'user_reminder',
			'module_enabled'	=> 1,
			'module_display'	=> 1,
			'parent_id'			=> (int) $user_reminder['module_id'],
			'module_class'		=> 'acp',
			'module_langname'	=> 'ACP_USER_REMINDER_CONFIGURATION',
			'module_mode'		=> 'configuration',
			'module_auth'		=> 'acl_a_user || acl_a_userdel',
		);
		$_module->update_module_data($user_reminder_configuration);
		$user_reminder_zero_poster = array(
			'module_basename'	=> 'user_reminder',
			'module_enabled'	=> 1,
			'module_display'	=> 1,
			'parent_id'			=> (int) $user_reminder['module_id'],
			'module_class'		=> 'acp',
			'module_langname'	=> 'ACP_USER_REMINDER_ZERO_POSTER',
			'module_mode'		=> 'zero_poster',
			'module_auth'		=> 'acl_a_user || acl_a_userdel',
		);
		$_module->update_module_data($user_reminder_zero_poster);
		$user_reminder_inactive = array(
			'module_basename'	=> 'user_reminder',
			'module_enabled'	=> 1,
			'module_display'	=> 1,
			'parent_id'			=> (int) $user_reminder['module_id'],
			'module_class'		=> 'acp',
			'module_langname'	=> 'ACP_USER_REMINDER_INACTIVE',
			'module_mode'		=> 'inactive',
			'module_auth'		=> 'acl_a_user || acl_a_userdel',
		);
		$_module->update_module_data($user_reminder_inactive);
		$user_reminder_not_logged_in = array(
			'module_basename'	=> 'user_reminder',
			'module_enabled'	=> 1,
			'module_display'	=> 1,
			'parent_id'			=> (int) $user_reminder['module_id'],
			'module_class'		=> 'acp',
			'module_langname'	=> 'ACP_USER_REMINDER_NOT_LOGGED_IN',
			'module_mode'		=> 'not_logged_in',
			'module_auth'		=> 'acl_a_user || acl_a_userdel',
		);
		$_module->update_module_data($user_reminder_not_logged_in);
		$user_reminder_inactive_still = array(
			'module_basename'	=> 'user_reminder',
			'module_enabled'	=> 1,
			'module_display'	=> 1,
			'parent_id'			=> (int) $user_reminder['module_id'],
			'module_class'		=> 'acp',
			'module_langname'	=> 'ACP_USER_REMINDER_INACTIVE_STILL',
			'module_mode'		=> 'inactive_still',
			'module_auth'		=> 'acl_a_user || acl_a_userdel',
		);
		$_module->update_module_data($user_reminder_inactive_still);
						
		$user_reminder_protected_users = array(
			'module_basename'	=> 'user_reminder',
			'module_enabled'	=> 1,
			'module_display'	=> 1,
			'parent_id'			=> (int) $user_reminder['module_id'],
			'module_class'		=> 'acp',
			'module_langname'	=> 'ACP_USER_REMINDER_PROTECTED_USERS',
			'module_mode'		=> 'protected_users',
			'module_auth'		=> 'acl_a_user || acl_a_userdel',
		);
		$_module->update_module_data($user_reminder_protected_users);
	}					
	
}

?>